<script>
  import { json } from "d3-fetch";
  import { onMount } from "svelte";

  import Controls from "./_ex_3_controls.svelte";
  import Scatterplot from "./_ex_3_scatterplot.svelte";

  // Load the data
  let data = null;
  onMount(async () => {
    data = await json("/data/gapminder.json");
  });
  
  export let selected_year = 0;  
  export let selected_continent;

  function mod(selected_year, selected_continent) {
    if (selected_continent == 'all') {
      return data[selected_year]['countries'].filter(d => d['income'] !== null && d['life_exp'] !== null)
    } else {
      return data[selected_year]['countries'].filter(d => d['continent'] == selected_continent && d['income'] !== null && d['life_exp'] !== null)
    }
  }

</script>

{#if !data}
  <p>Loading the data, please wait...</p>
{:else}
  <div>
    <Scatterplot data={mod(selected_year, selected_continent)} />
    <Controls {data} bind:selected_year={selected_year} bind:selected_continent={selected_continent}/>
  </div>
{/if}
